<template>
  <div>
    <h1 class="heading" v-if="category">{{ category.title }}</h1>
    <ProductList :products="products" /> 
    <div class="empty" v-if="products.length === 0">
      <h2 class="empty__title">متاسفانه محصولی برای نمایش وجود ندارد!</h2>
    </div>
  </div>
</template>

<script>
import ProductList from "@/components/catalog/ProductList";
import { categoryOne } from "@/dummies/data.js";

export default {
  components: {
    ProductList
  },
  async asyncData(context) {
    let category = {};
    let products = [];
    let notFound = false;
    const id = context.route.params.id;
    // fetch category
    await context.store.dispatch('shop/fetchCategory', id).then(response => {
      category = response.data.data;
    }).catch(error => {
      if (error.response.status === 404) {
        notFound = true
      }
    });
    // fetch products
    if (!notFound) {
      await context.store.dispatch('shop/fetchCategoryProducts', id).then(response => {
        products = response.data.data;
      }).catch(error => {
        if (error.response.status === 404) {
          notFound = true
        }
      });
    }
    return {
      category,
      products,
      notFound
    }
  },
  head() {
    return {
      title: this.category.title
    }
  },
  mounted() {
    this.$store.dispatch('settings/setBackRoute', '/shop');
    if (!this.category.id) throw new Error("Category not found");
  },
  beforeDestroy() {
    this.$store.dispatch('settings/setBackRoute', '');
  }
}
</script>

<style lang="stylus" scoped>
@import '~assets/styles/variables'
.heading
  font-size 3.6rem
  margin-bottom $lg
  color $white
  font-weight 200
  @media only screen and (max-width: 600px)
    font-size 3rem
    margin-bottom $md

.empty
  margin-bottom $lg
  &__title
    color $white
    opacity .75
    text-align center
    @media only screen and (max-width 700px)
      font-size 2rem
      padding $md $xsm
    @media only screen and (max-width 500px)
      font-size 1.8rem
    @media only screen and (max-width 460px)
      font-size 1.6rem
</style>